
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Voyager.Strategies.xtricorder &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for Voyager.Strategies.xtricorder</h1><div class="highlight"><pre>
<span></span>
<span class="c1">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1">#####################################################################</span>
<span class="c1">#  Copyright and authorship belong to:                              #</span>
<span class="c1">#  @author: Massimo Sammito                                         #</span>
<span class="c1">#  @email: mds83@cam.ac.uk / massimo.sammito@gmail.com              #</span>
<span class="c1">#####################################################################</span>
<span class="c1">#####################################################################</span>
<span class="c1">#                              LICENSE                              #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#####################################################################</span>

<span class="c1">#DISCLAIMER#</span>
<span class="c1">#This class has been generated automatically through strategy_app.py</span>
<span class="c1">#The app does not verify the correctness of the written code</span>
<span class="c1">#Please validate the class before use and manually inspect and correct any error</span>

<span class="c1"># System imports</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">division</span>
<span class="kn">from</span> <span class="nn">future.standard_library</span> <span class="kn">import</span> <span class="n">install_aliases</span>

<span class="n">install_aliases</span><span class="p">()</span>

<span class="kn">import</span> <span class="nn">os</span><span class="o">,</span> <span class="nn">sys</span><span class="o">,</span> <span class="nn">copy</span>
<span class="n">module_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="vm">__file__</span><span class="p">))</span>
<span class="n">voyager_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">module_path</span><span class="p">,</span><span class="s2">&quot;../&quot;</span><span class="p">)</span>
<span class="n">sys</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">voyager_path</span><span class="p">)</span>

<span class="kn">import</span> <span class="nn">phasertng.phil.master_phil_file</span>
<span class="kn">import</span> <span class="nn">networkx</span> <span class="k">as</span> <span class="nn">nx</span>
<span class="kn">import</span> <span class="nn">voyager_dag</span>
<span class="kn">import</span> <span class="nn">voyager_strategy</span>

<span class="kn">from</span> <span class="nn">Actions</span> <span class="kn">import</span> <span class="n">SGX</span><span class="p">,</span><span class="n">TNCS</span><span class="p">,</span><span class="n">TWIN</span><span class="p">,</span><span class="n">SGA</span><span class="p">,</span><span class="n">ANO_TNCSO</span><span class="p">,</span><span class="n">DATA</span>

<span class="n">masterphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
        
<span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">item</span> <span class="ow">in</span> <span class="n">phasertng</span><span class="o">.</span><span class="n">phil</span><span class="o">.</span><span class="n">master_phil_file</span><span class="o">.</span><span class="n">implemented</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
    <span class="k">if</span> <span class="n">key</span> <span class="ow">in</span> <span class="p">[</span><span class="s2">&quot;hklin&quot;</span><span class="p">]:</span> <span class="k">continue</span>
    <span class="n">masterphil</span> <span class="o">+=</span> <span class="s2">&quot;voyager.phasertng.&quot;</span> <span class="o">+</span> <span class="n">item</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>

<span class="n">masterphil</span> <span class="o">+=</span> <span class="s2">&quot;&quot;&quot;</span>
<span class="s2">voyager.mode = *xtricorder</span>
<span class="s2">    .type = choice(multi=False)</span>
<span class="s2">    .expert_level = 0</span>
<span class="s2">    .short_caption = phaser.voyager mode</span>
<span class="s2">    .help = Call phaser with functionality</span>
<span class="s2">    .caption = Initialize phaser.voyager and configure connection with the GUI                Read_mtz_file and perform data analysis and corrections                Define assemblies and check consistency with the data                Extracting and evaluate ensembles for all the assembly components                Define a MR strategy and follow results with MRTree                Define and perform a full run     .style = bold phaser:ignore OnChange:update_phaser_mode renderer:draw_phaser_mode_widget</span>

<span class="s2">voyager.DATA {</span>

<span class="s2">}</span>
<span class="s2">voyager.ANO_TNCSO {</span>

<span class="s2">}</span>
<span class="s2">voyager.TNCS {</span>

<span class="s2">}</span>
<span class="s2">voyager.TWIN {</span>

<span class="s2">}</span>
<span class="s2">voyager.SGA {</span>
<span class="s2">perform_space_group_expansion_only_if_twinned = True</span>
<span class="s2">  .type = bool</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = Criteria to activate the expansion</span>
<span class="s2">  .help = It will perform the space group expansion only for those datasets that have found to be twinned.</span>
<span class="s2">}</span>
<span class="s2">voyager.SGX {</span>

<span class="s2">}</span>

<span class="s2">&quot;&quot;&quot;</span>
            
<div class="viewcode-block" id="xtricorder"><a class="viewcode-back" href="../../../Voyager.Strategies.xtricorder.html#Voyager.Strategies.xtricorder.xtricorder">[docs]</a><span class="k">class</span> <span class="nc">xtricorder</span><span class="p">(</span><span class="n">voyager_strategy</span><span class="o">.</span><span class="n">VoyagerStrategy</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">argsparse</span><span class="p">,</span> <span class="n">program_master_phil</span><span class="p">,</span> <span class="n">states</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">xtricorder</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">argsparse</span><span class="p">,</span> <span class="n">program_master_phil</span><span class="p">,</span> <span class="n">states</span><span class="o">=</span><span class="n">states</span><span class="p">)</span>

        
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_node</span><span class="p">(</span><span class="n">DATA</span><span class="o">.</span><span class="n">DATA</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;&quot;&quot;</span>


<span class="s2">voyager.DATA {</span>

<span class="s2">}&quot;&quot;&quot;</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_node</span><span class="p">(</span><span class="n">ANO_TNCSO</span><span class="o">.</span><span class="n">ANO_TNCSO</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;&quot;&quot;</span>


<span class="s2">voyager.ANO_TNCSO {</span>

<span class="s2">}&quot;&quot;&quot;</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_loop_sequence_data_node</span><span class="p">(</span><span class="kc">None</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_node</span><span class="p">(</span><span class="n">TNCS</span><span class="o">.</span><span class="n">TNCS</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;&quot;&quot;</span>


<span class="s2">voyager.TNCS {</span>

<span class="s2">}&quot;&quot;&quot;</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_node</span><span class="p">(</span><span class="n">TWIN</span><span class="o">.</span><span class="n">TWIN</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;&quot;&quot;</span>


<span class="s2">voyager.TWIN {</span>

<span class="s2">}&quot;&quot;&quot;</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_node</span><span class="p">(</span><span class="n">SGA</span><span class="o">.</span><span class="n">SGA</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;&quot;&quot;</span>

<span class="s2">voyager.SGA {</span>
<span class="s2">perform_space_group_expansion_only_if_twinned = True</span>
<span class="s2">  .type = bool</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = Criteria to activate the expansion</span>
<span class="s2">  .help = It will perform the space group expansion only for those datasets that have found to be twinned.</span>
<span class="s2">}&quot;&quot;&quot;</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_loop_sequence_data_node</span><span class="p">(</span><span class="kc">None</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_node</span><span class="p">(</span><span class="n">SGX</span><span class="o">.</span><span class="n">SGX</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;&quot;&quot;</span>

<span class="s2">voyager.SGX {</span>

<span class="s2">}&quot;&quot;&quot;</span><span class="p">),</span> <span class="kc">None</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_end_node</span><span class="p">(</span><span class="kc">None</span><span class="p">)</span>
                
        <span class="bp">self</span><span class="o">.</span><span class="n">add_end_strategy_node</span><span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="s2">&quot;xtricorder&quot;</span><span class="p">,</span><span class="kc">False</span><span class="p">,</span><span class="mi">0</span><span class="p">)</span>
                    
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_edge</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_edge</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">2</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_edge</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span><span class="mi">3</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_edge</span><span class="p">(</span><span class="mi">3</span><span class="p">,</span><span class="mi">4</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_edge</span><span class="p">(</span><span class="mi">4</span><span class="p">,</span><span class="mi">5</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_edge</span><span class="p">(</span><span class="mi">5</span><span class="p">,</span><span class="mi">6</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_edge</span><span class="p">(</span><span class="mi">6</span><span class="p">,</span><span class="mi">7</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_edge</span><span class="p">(</span><span class="mi">7</span><span class="p">,</span><span class="mi">8</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">add_action_edge</span><span class="p">(</span><span class="mi">8</span><span class="p">,</span><span class="mi">9</span><span class="p">)</span></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>